module Event
  class DeleteProject < Base
    self.message_bus_routing_key = 'project.delete'
    self.description = 'Project was deleted'
    payload_keys :project, :comment, :requestid, :sender

    private

    def metric_tags
      { home: ::Project.home?(payload['project']) }
    end

    def metric_fields
      { value: 1 }
    end
  end
end

# == Schema Information
#
# Table name: events
#
#  id          :integer          not null, primary key
#  eventtype   :string(255)      not null, indexed
#  payload     :text(65535)
#  created_at  :datetime         indexed
#  updated_at  :datetime
#  undone_jobs :integer          default(0)
#  mails_sent  :boolean          default(FALSE), indexed
#
# Indexes
#
#  index_events_on_created_at  (created_at)
#  index_events_on_eventtype   (eventtype)
#  index_events_on_mails_sent  (mails_sent)
#
